/*___________________________________________

	        F O R M   C L O S I N G   D E M O
			                  Ron Kessler
					   Created 11/3/2016


This project shows how to do a confirm exit no matter
how they close the form.

Create a Form_Closing event.
Then put your MsgBox in that handler.

In the btnExit click event, just do a this->Close(); because
this will raise the Form_Closing event.

Look at my comments below


*/






#pragma once

namespace Form_Closing_Demo {

	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;

	/// <summary>
	/// Summary for frmMain
	/// </summary>
	public ref class frmMain : public System::Windows::Forms::Form
	{
	public:
		frmMain(void)
		{
			InitializeComponent();
			this->CenterToScreen();
		}

#pragma region Windows Form Designer generated code
	protected:
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		~frmMain()
		{
			if (components)
			{
				delete components;
			}
		}
	private: System::Windows::Forms::Button^  btnQuit;
	private: System::Windows::Forms::MenuStrip^  menuStrip1;
	private: System::Windows::Forms::ToolStripMenuItem^  fileToolStripMenuItem;
	private: System::Windows::Forms::ToolStripMenuItem^  mnuFile_Exit;
	protected:

	private:
		/// <summary>
		/// Required designer variable.
		/// </summary>
		System::ComponentModel::Container ^components;


		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		void InitializeComponent(void)
		{
			this->btnQuit = (gcnew System::Windows::Forms::Button());
			this->menuStrip1 = (gcnew System::Windows::Forms::MenuStrip());
			this->fileToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->mnuFile_Exit = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuStrip1->SuspendLayout();
			this->SuspendLayout();
			// 
			// btnQuit
			// 
			this->btnQuit->Location = System::Drawing::Point(160, 127);
			this->btnQuit->Name = L"btnQuit";
			this->btnQuit->Size = System::Drawing::Size(75, 23);
			this->btnQuit->TabIndex = 0;
			this->btnQuit->Text = L"Quit";
			this->btnQuit->UseVisualStyleBackColor = true;
			this->btnQuit->Click += gcnew System::EventHandler(this, &frmMain::btnQuit_Click);
			// 
			// menuStrip1
			// 
			this->menuStrip1->ImageScalingSize = System::Drawing::Size(20, 20);
			this->menuStrip1->Items->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(1) { this->fileToolStripMenuItem });
			this->menuStrip1->Location = System::Drawing::Point(0, 0);
			this->menuStrip1->Name = L"menuStrip1";
			this->menuStrip1->Size = System::Drawing::Size(379, 28);
			this->menuStrip1->TabIndex = 1;
			this->menuStrip1->Text = L"menuStrip1";
			// 
			// fileToolStripMenuItem
			// 
			this->fileToolStripMenuItem->DropDownItems->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(1) { this->mnuFile_Exit });
			this->fileToolStripMenuItem->Name = L"fileToolStripMenuItem";
			this->fileToolStripMenuItem->Size = System::Drawing::Size(44, 24);
			this->fileToolStripMenuItem->Text = L"File";
			// 
			// mnuFile_Exit
			// 
			this->mnuFile_Exit->Name = L"mnuFile_Exit";
			this->mnuFile_Exit->Size = System::Drawing::Size(181, 26);
			this->mnuFile_Exit->Text = L"Exit";
			this->mnuFile_Exit->Click += gcnew System::EventHandler(this, &frmMain::mnuFile_Exit_Click);
			// 
			// frmMain
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(8, 16);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->ClientSize = System::Drawing::Size(379, 321);
			this->Controls->Add(this->btnQuit);
			this->Controls->Add(this->menuStrip1);
			this->MainMenuStrip = this->menuStrip1;
			this->Margin = System::Windows::Forms::Padding(4);
			this->Name = L"frmMain";
			this->StartPosition = System::Windows::Forms::FormStartPosition::CenterScreen;
			this->Text = L"Form1";
			this->FormClosing += gcnew System::Windows::Forms::FormClosingEventHandler(this, &frmMain::frmMain_FormClosing);
			this->menuStrip1->ResumeLayout(false);
			this->menuStrip1->PerformLayout();
			this->ResumeLayout(false);
			this->PerformLayout();

		}
#pragma endregion

		//*************START OF MY CODE*************

		private: System::Void mnuFile_Exit_Click(System::Object^  sender, System::EventArgs^  e)
		{
			DoExit();			//cancel from a menu?
		}


		private: System::Void btnQuit_Click(System::Object^  sender, System::EventArgs^  e) 
		{
			//DoExit();			//this will trigger the Form_Closing event
			this->Close();
		}

		private: void DoExit()
		{
			this->Close();


		}
	
		private: System::Void frmMain_FormClosing(System::Object^  sender, System::Windows::Forms::FormClosingEventArgs^  e) 
		{
		
			//pressing the X, or using the control box, or using ALT-F4 will raise this event automatically
			//---if they say NO to quitting, then cancel the form_closing event. Otherwise, just keep running
			if (MessageBox::Show("Are you sure?", "System Message",
				MessageBoxButtons::YesNo) == System::Windows::Forms::DialogResult::No)

				e->Cancel = true;		//CANCELS THE FORM_CLOSING EVENT and keeps the app running
		
		}
	
};
}
